﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xrm.Sdk.Client;
using System.ServiceModel.Description;

namespace EarlyBindingConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            //string newAccountId = CreateAccount("Webfortis", "new damian");
            //  UpdateAccount("Webfortis", new Guid(newAccountId));
            //RetrieveAccount("Webfortis", new Guid(newAccountId));
            //GetAllAccounts("Webfortis");

            //   Console.WriteLine("Account entity exists = " + CheckEntity("Webfortis", "Account"));
            // Console.WriteLine("new_ MyNewCustomEntity entity exists = " + CheckEntity("Webfortis", "new_ MyNewCustomEntity"));
            //CreateCustomEntity("Webfortis", "new_MyNewCustomEntity");
            GetShippingMethod("Webfortis");
            Console.ReadLine();
        }
        private static string CreateAccount(string organizationName, string accountName)
        {
            ClientCredentials credentials = new ClientCredentials();
            credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
            OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
                null, credentials, null);

            _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());

            OrganizationServiceContext orgContext = new OrganizationServiceContext(_serviceProxy);
            Account account = new Account()
                {
                    Name = accountName
                };
            orgContext.AddObject(account);
            orgContext.SaveChanges();
            return account.AccountId.ToString();
        }

        private static Account RetrieveAccount(string organizationName, Guid accountId)
        {
            ClientCredentials credentials = new ClientCredentials();
            credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
            OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
                null, credentials, null);

            _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());

            OrganizationServiceContext orgContext = new OrganizationServiceContext(_serviceProxy);
            Account account = (from a in orgContext.CreateQuery<Account>() where a.AccountId == accountId select a).Single();
            return account;
        }

        private static void GetAllAccounts(string organizationName)
        {
            ClientCredentials credentials = new ClientCredentials();
            credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
            OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
                null, credentials, null);

            _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());
            OrganizationServiceContext orgContext = new OrganizationServiceContext(_serviceProxy);

            /// Retrieve the accounts.
            var accounts = from a in orgContext.CreateQuery<Account>() select a;
            foreach (Account myAccount in accounts)
            {
                Console.WriteLine(myAccount.Name);
            }
        }
        private static void DeleteAccount(string organizationName, Guid accountToDelete)
        {
            ClientCredentials credentials = new ClientCredentials();
            credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
            OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
                null, credentials, null);

            _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());

            OrganizationServiceContext orgContext = new OrganizationServiceContext(_serviceProxy);

            Account account = (from a in orgContext.CreateQuery<Account>() where a.AccountId == accountToDelete select a).Single();
            orgContext.DeleteObject(account);
            orgContext.SaveChanges();


            _serviceProxy.Delete(Account.EntityLogicalName, accountToDelete);


        }
        private static void UpdateAccount(string organizationName, Guid accountToUpdate)
        {
            ClientCredentials credentials = new ClientCredentials();
            credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
            OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
                null, credentials, null);

            _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());

            OrganizationServiceContext orgContext = new OrganizationServiceContext(_serviceProxy);

            Account account = (from a in orgContext.CreateQuery<Account>() where a.AccountId == accountToUpdate select a).Single();
            account.Name = "ddddddddddddd";
            orgContext.UpdateObject(account);
            orgContext.SaveChanges();

            _serviceProxy.Update(account);

        }

        private static bool CheckEntity(string organizationName, string entityName)
        {
            try
            {

                ClientCredentials credentials = new ClientCredentials();
                credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
                OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
                    null, credentials, null);

                _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());


                Microsoft.Xrm.Sdk.Messages.RetrieveEntityRequest myRequest = new Microsoft.Xrm.Sdk.Messages.RetrieveEntityRequest();
                myRequest.LogicalName = entityName.ToLower();
                Microsoft.Xrm.Sdk.Messages.RetrieveEntityResponse myResponse;
                myResponse = (Microsoft.Xrm.Sdk.Messages.RetrieveEntityResponse)_serviceProxy.Execute(myRequest);
                return true;

            }
            catch (Exception ex)
            {
                Console.WriteLine("General exception: " + ex.ToString());
                return false;
            }
        }
        private static bool CreateCustomEntity(string organizationName, string entityName)
        {
            try
            {
                ClientCredentials credentials = new ClientCredentials();
                credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
                OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
                    null, credentials, null);

                _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());

                // Creates new entity
                Microsoft.Xrm.Sdk.Metadata.EntityMetadata myNewEntity = new Microsoft.Xrm.Sdk.Metadata.EntityMetadata();
                myNewEntity.Description = CreateLabel(entityName);
                myNewEntity.DisplayCollectionName = CreateLabel(entityName);
                myNewEntity.DisplayName = CreateLabel(entityName);

                myNewEntity.IsAvailableOffline = true;


                myNewEntity.SchemaName = entityName;
                myNewEntity.LogicalName = entityName;
                myNewEntity.OwnershipType = Microsoft.Xrm.Sdk.Metadata.OwnershipTypes.UserOwned;

                // creates primary attribute
                Microsoft.Xrm.Sdk.Metadata.StringAttributeMetadata myPrimaryAttr = new Microsoft.Xrm.Sdk.Metadata.StringAttributeMetadata();
                myPrimaryAttr.DisplayName = CreateLabel("Name");
                myPrimaryAttr.Description = CreateLabel("this is the Name");

                myPrimaryAttr.MaxLength = 100;
                myPrimaryAttr.SchemaName = "new_Name";
                myPrimaryAttr.Format = Microsoft.Xrm.Sdk.Metadata.StringFormat.Text;

                myPrimaryAttr.RequiredLevel = new Microsoft.Xrm.Sdk.Metadata.AttributeRequiredLevelManagedProperty(Microsoft.Xrm.Sdk.Metadata.AttributeRequiredLevel.ApplicationRequired);

                myPrimaryAttr.LogicalName = "new_name";

                // prepare request
                Microsoft.Xrm.Sdk.Messages.CreateEntityRequest myRequest = new Microsoft.Xrm.Sdk.Messages.CreateEntityRequest();
                myRequest.Entity = myNewEntity;
                myRequest.HasActivities = true;
                myRequest.HasNotes = true;
                myRequest.PrimaryAttribute = myPrimaryAttr;

                Microsoft.Xrm.Sdk.Messages.CreateEntityResponse myResponse;
                myResponse = (Microsoft.Xrm.Sdk.Messages.CreateEntityResponse)_serviceProxy.Execute(myRequest);
                return true;
            }
            catch (Exception ex)
            {
                Console.WriteLine("General exception: " + ex.ToString());
                return false;
            }
        }
        private static Microsoft.Xrm.Sdk.Label CreateLabel(string myString)
        {
            Microsoft.Xrm.Sdk.Label myLabel = new Microsoft.Xrm.Sdk.Label();
            Microsoft.Xrm.Sdk.LocalizedLabel myLabels = new Microsoft.Xrm.Sdk.LocalizedLabel(myString, 1033);// English code
            myLabel.LocalizedLabels.Add(myLabels);
            return myLabel;
        }

private static void GetShippingMethod(string organizationName)
{
    ClientCredentials credentials = new ClientCredentials();
    credentials.Windows.ClientCredential = System.Net.CredentialCache.DefaultNetworkCredentials;
    OrganizationServiceProxy _serviceProxy = new OrganizationServiceProxy(new Uri("http://crm2011/" + organizationName + "/XRMServices/2011/Organization.svc"),
        null, credentials, null);

    _serviceProxy.ServiceConfiguration.CurrentServiceEndpoint.Behaviors.Add(new ProxyTypesBehavior());
         
    Microsoft.Xrm.Sdk.Messages.RetrieveAttributeRequest myRequest = new Microsoft.Xrm.Sdk.Messages.RetrieveAttributeRequest();            
    myRequest.EntityLogicalName = Account.EntityLogicalName;
    myRequest.LogicalName = "address1_shippingmethodcode";

    Microsoft.Xrm.Sdk.Messages.RetrieveAttributeResponse myResponse;
    myResponse = (Microsoft.Xrm.Sdk.Messages.RetrieveAttributeResponse)_serviceProxy.Execute(myRequest);
    foreach (Microsoft.Xrm.Sdk.Metadata.OptionMetadata myOption in ((Microsoft.Xrm.Sdk.Metadata.PicklistAttributeMetadata)(myResponse.AttributeMetadata)).OptionSet.Options)
    {
        Console.WriteLine(myOption.Label.LocalizedLabels[0].Label);
    }
}


    }
}
